<?php
    /*
        Plugin Name: AdMangler
        Plugin URI: http://www.webternals.com/projects/admangler/
        Description: Display, sell, and manage ad space on your Wordpress powered site with AdMangler.
        Version: 0.0.8.5.Alpha
        Author: Webternals, LLC - Allen Sanford
        Author URI: http://www.webternals.com/
    */

    if (!session_id())
        session_start();

    // Check for class include and activete the class
    if (!class_exists('AdMangler'))
    {
        require_once(dirname(__FILE__).'/adMangler.class.php');
        $adMangler = new AdMangler();
        require_once(dirname(__FILE__).'/adManglerWidget.class.php');
    } // End if (!class_exists('AdMangler')

    //Setup actions, hooks and filters
    if (isset($adMangler))
    {
        // Generate the Admin Menu
        if ( is_admin() )
        {
            // Activation function
            register_activation_hook(__FILE__, array('AdMangler', 'Activate'));
            add_action('admin_menu', array($adMangler, 'AdminMenu'));
            wp_enqueue_script('admanglertooltip', '/' . PLUGINDIR . '/admangler/js/tooltip.js');
        }
        else
        {
            add_filter('the_content', array($adMangler, 'FilterTheContent'));
            add_shortcode('AdMangler', array($adMangler, 'ShortCodeHandler'));
        }
        add_action('init', array('AdMangler', 'RegisterWidgets'), 1);
        wp_enqueue_script("jquery");
        wp_enqueue_script('jquery.validate', '/' . PLUGINDIR . '/admangler/js/jquery.validate.min.js');
    
    } // End if (isset($adMangler))
?>
